import { ElPagination } from 'element-plus'
import { defineComponent } from 'vue'
import styles from './index.module.less'

export default defineComponent({
  name: 'pagination',
  props: {
    total: {
      required: true,
      type: Number
    },
    page: {
      type: Number,
      default: 1
    },
    limit: {
      type: Number,
      default: 10
    },
    pageSizes: {
      type: Array,
      default: [5,10, 20, 30, 50]
    },
    layout: {
      type: String,
      default: 'total, sizes, prev, pager, next, jumper'
    },
    background: {
      type: Boolean,
      default: true
    },
    autoScroll: {
      type: Boolean,
      default: true
    },
    hidden: {
      type: Boolean,
      default: false
    },
    sync: {
      type: Boolean,
      default: false
    },
    saveKey: {
      type: String,
      default: ''
    },
    pagination: {
      type: Function,
      default: () => {}
    }
  },
  methods: {
    handleSizeChange(val: number) {
      console.log(val, 'headleSizeChange')
      this.$emit('update:page', 1)
      this.$emit('update:limit', val)
      this.pagination()
      if (this.autoScroll) {
        scrollTo(0, 800)
      }
    },
    handleCurrentChange(val: number) {
      console.log(val, 'val')
      // this.$emit('pagination', { page: val, limit: this.limit })
      if (this.autoScroll) {
        scrollTo(0, 800)
      }
    }
  },
  render() {
    // console.log(this.pageSizes)
    return (
      <div
        class={[styles['pagination-container'], this.hidden && styles.hidden]}
      >
        <ElPagination
          v-model:currentPage={this.page}
          pageSize={this.limit}
          // @ts-ignore
          onUpdate:pageSize={(val: number) => {
            this.handleSizeChange(val)
          }}
          pageSizes={this.pageSizes as number[]}
          total={this.total}
          hideOnSinglePage={true}
          background
          layout="total, sizes, prev, pager, next, jumper"
          onSise-change={this.handleSizeChange}
          onCurrent-change={this.handleCurrentChange}
        />
      </div>
    )
  }
})
